from PyQt4 import QtGui, QtCore

class FlockDrawer(QtGui.QWidget):
	"""
	Represents a canvas for drawing the boids
	"""
	def __init__(self, parent=None):
		super(FlockDrawer, self).__init__(parent)
		self._boids = []		# contains boids (used for drawing)
		# self.setMinimumSize(400, 300)
		self.setSizePolicy(QtGui.QSizePolicy.Minimum, QtGui.QSizePolicy.Minimum)
		# self.setSizeHint(450, 300)
		self._painter = QtGui.QPainter()
		# self.painter.setBrush(QtGui.QColor(255,127,0))
		self.setStyleSheet("background-color: white;")

		self.show()
		self.setAutoFillBackground(True)

	def paintEvent(self, e):
		"""
		Draws data on screen
		"""
		# painter = QtGui.QPainter()
		self.painter.begin(self)
		self.draw_boids(self.painter)
		self.painter.end()

	def sizeHint(self):
		"""
		Describes the preferred minimum size
		"""
		return QtCore.QSize(400, 240)

	def draw_boids(self, painter):
		"""
		Draws every boid to the given painter
		"""
		for boid in self.boids:
			self.draw_boid(painter, boid)

	def draw_boid(self, painter, boid):
		"""
		Draws a single boid to the given painter
		"""
		radius=4
		direction_length = 10
		# circle
		# painter.setBrush(QtGui.QColor(255,127,0))
		painter.drawEllipse(boid.position.real-radius,
			boid.position.imag-radius, radius*2, radius*2)
		# orientation marker line
		oripos = boid.orientation*direction_length + boid.position
		painter.drawLine(boid.position.real, boid.position.imag,
			oripos.real, oripos.imag)

	######################
	#### Getters & setters

	def get_painter(self):
		return self._painter
	painter = property(get_painter)

	def get_boids(self):
		return self._boids

	def set_boids(self, boids):
		self._boids = boids
	boids = property(get_boids, set_boids)
